/******************************************************
 * Sgorpi MultiTrack Writer
 * By: Hedde Bosman
 * 
 * This code is provided as is, without any warranty.
 * You are free to copy/use the code as long as you 
 * mention my name, in the code and/or about box.
 */
#ifndef __WAVEFILE_H__
#define __WAVEFILE_H__

#include <stdio.h>
#include <windows.h>
#include <mmreg.h>

#include <exception>

enum waveType {
	W08,
	W16,
	W24,
	W0_24, // ieee float 0.24 waves are normalized from [-1,+1)
	W24_0, // pcm float 24.0 waves are normalized from [-8milion,+8milion)
	W16_8, // pcm float 16.8 waves are normalized from [-32768, 32768)
};

class WaveFile {
public:
	WaveFile(char *filename, bool rw, int smprate = 44100, waveType t = W16, bool stereo = false);
	~WaveFile();

	long readBuf(int numsmp, float *buf);
	void writeBuf(int numsmp, float *buf);

	bool isStereo();
	int getSampleRate();
	waveType getWaveType();

private:
	FILE *f;
	waveType type;
	bool stereo;
	int samplerate;

	bool readwrite; // read = false, write = true
	long filesize;
	long headersize;
	long dataSize;
	char hdr[5];

	void checkReadDataSize();
};

#endif