/******************************************************
 * Sgorpi MultiTrack Writer
 * By: Hedde Bosman
 * 
 * This code is provided as is, without any warranty.
 * You are free to copy/use the code as long as you 
 * mention my name, in the code and/or about box.
 */
#include "sgorpi_mtw.h"
#include <shlobj.h>
#include "resrc1.h"

HINSTANCE dllInstance;
HWND hwnd = NULL;
BOOL CALLBACK MixDialogProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
HWND font;

HDC hdc, bbdc;
HBITMAP bm;

RECT updateRect;
RECT invalidRect = {1,1,2,2};

HBRUSH green_l, green_d, red_l, red_d, black, windowc;

SCROLLINFO hscrl;
int scrollpos = 1;
bool updateScroll = false;

bool mi::HandleDoubleClick(void * ptr) {
	if (hwnd == NULL) {
		if (strlen(outputDir) == 0) {
			GetCurrentDirectory(512, outputDir);
		}
		hwnd = CreateDialog(dllInstance, MAKEINTRESOURCE(IDD_DIALOGMIX), GetForegroundWindow(), (DLGPROC)&MixDialogProc);
		SendDlgItemMessage(hwnd, IDC_EDIT1, WM_SETTEXT, 0, (LPARAM)outputDir);
	}
	ShowWindow(hwnd, SW_SHOW);
	return true; // return true to block param window
}

void setMixerColumnPos(int i) {
	int p = i-scrollpos+1;
	SetWindowPos(machines[i].groupbox, hwnd, p*75+7,35,70,200, SWP_NOZORDER);
	SetWindowPos(machines[i].buttonRec, hwnd, p*75+13,55,46,18, SWP_NOZORDER);
	SetWindowPos(machines[i].sliderVol, hwnd, p*75+13,73,37,145, SWP_NOZORDER);
	SetWindowPos(machines[i].text, hwnd, p*75+12,217,50,14, SWP_NOZORDER);
}
void DrawVUmeter(mi *pmi, int i) {
	RECT line;
	int vl, vr;
	vl = (int)(pmi->MaxValueLeft/381.0f);
	vr = (int)(pmi->MaxValueRight/381.0f);
	line.bottom = 0;
	line.top = 129;
	line.left = 0;
	line.right = 4;
	// left
	FillRect(bbdc, &line, black );
	line.left = 7;
	line.right = 11;
	// right
	FillRect(bbdc, &line, black );
	//center
	line.bottom = 0;
	line.top = 129;
	line.left = 4;
	line.right = 7;
	FillRect(bbdc, &line, windowc );
	if (vl >= 0) {
		if (pmi->maxValue > 0.0) {
			line.bottom = 130-(int)(pmi->maxValue/381.0f);
			if (line.bottom < 1) line.bottom = 1;
			line.top = line.bottom-2;
			line.left = 4;
			line.right = 7;
			if (line.bottom > 43) {
				FillRect(bbdc, &line, green_d );
			} else {
				FillRect(bbdc, &line, red_d );
			}
		}

		//left
		// lineheight = 129
		// norm = 86
		if (vl > 86) {
			line.bottom = 129-vl;
			line.top = 87;
			line.left = 0;
			line.right = 4;
			FillRect(bbdc, &line, red_l );
			vl = 86;
		}
		line.bottom = 129-vl;
		line.top = 129;
		line.left = 0;
		line.right = 4;
		FillRect(bbdc, &line, green_l );
		//right
		// lineheight = 129
		// norm = 86
		if (vr > 86) {
			line.bottom = 129-vr;
			line.top = 87;
			line.left = 7;
			line.right = 11;
			FillRect(bbdc, &line, red_l );
			vr = 86;
		}
		line.bottom = 129-vr;
		line.top = 129;
		line.left = 7;
		line.right = 11;
		FillRect(bbdc, &line, green_l );
	}
}
BOOL CALLBACK MixDialogProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) 
{
	int i;
	static char voltxt[50];
	switch(uMsg) {
		case WM_INITDIALOG:
			DefWindowProc(hDlg, WM_SETTEXT, 0, (LPARAM)"Sgorpi's MultiTrack Writer");
			font = (HWND)SendMessage(hDlg, WM_GETFONT, (WPARAM)0,(LPARAM)0);
			SendDlgItemMessage(hDlg, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM)"16bit");
			SendDlgItemMessage(hDlg, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM)"24bit");
			SendDlgItemMessage(hDlg, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM)"32bit type 1 (16.8) ");
			SendDlgItemMessage(hDlg, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM)"32bit type 1 (24.0)");
			SendDlgItemMessage(hDlg, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM)"32bit type 3 (0.24)");
			SendDlgItemMessage(hDlg, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM)"8bit");
			SendDlgItemMessage(hDlg, IDC_COMBO1, CB_SELECTSTRING, 0, (LPARAM)"32bit type 3");
			return 1;

		case WM_SHOWWINDOW:
			SendDlgItemMessage(hwnd, IDC_EDIT1, WM_SETTEXT, 0, (LPARAM)outputDir);
			for (i = 0; i < numMachines; i++) {
				if (!machines[i].added) {
					machines[i].added = true;
					machines[i].groupbox = CreateWindow("BUTTON", "gb", BS_GROUPBOX|WS_CHILD | WS_VISIBLE | BS_LEFT, i*75+7,35,70,200, hDlg, NULL, dllInstance, NULL);
					machines[i].buttonRec = CreateWindow("BUTTON", "rec", BS_AUTOCHECKBOX | BS_PUSHLIKE | WS_TABSTOP | WS_CHILD | WS_VISIBLE, i*75+13,55,46,18, hDlg, NULL, dllInstance, NULL);
					machines[i].sliderVol = CreateWindow(TRACKBAR_CLASS, "vol", WS_CHILD | WS_VISIBLE | TBS_VERT | TBS_BOTH | TBS_NOTICKS | WS_TABSTOP, i*75+13,73,40,145, hDlg, NULL, dllInstance, NULL);
					machines[i].text = CreateWindow("STATIC", "M 100.0%", WS_CHILD | WS_VISIBLE | SS_LEFT | DS_SETFONT, i*75+12,217,50,14, hDlg, NULL, dllInstance, NULL);
					SendMessage(machines[i].groupbox, WM_SETFONT, (WPARAM)font, (LPARAM)MAKELPARAM(TRUE, 0));
					SendMessage(machines[i].buttonRec, WM_SETFONT, (WPARAM)font, (LPARAM)MAKELPARAM(TRUE, 0));
					SendMessage(machines[i].text, WM_SETFONT, (WPARAM)font, (LPARAM)MAKELPARAM(TRUE, 0));
					SendMessage(machines[i].sliderVol, TBM_SETRANGE, (WPARAM)true, (LPARAM)MAKELONG(0,600));
					SendDlgItemMessage(hwnd, IDC_COMBO1, CB_SETCURSEL, (WPARAM)wavetype,0);
				}
			}
			hscrl.cbSize = sizeof(SCROLLINFO);
			hscrl.fMask = SIF_PAGE|SIF_RANGE;
			hscrl.nMax = numMachines;
			hscrl.nMin = 1;
			hscrl.nPage = 9;
			hscrl.nPos = scrollpos;
			SetScrollInfo(hDlg, SB_HORZ, &hscrl, false);
			return 1;

		case WM_CLOSE:
			ShowWindow(hDlg, SW_HIDE);
			return 0;

		case WM_COMMAND:
			//If a button or other control is clicked or something
			switch (LOWORD (wParam))
			{
				case IDC_EDIT1:
					break;
				case IDC_BUTTON2:
					{
						BROWSEINFO bnfo;
						ITEMIDLIST *idlst;
							
						memset(&bnfo, 0, sizeof(bnfo));
						bnfo.hwndOwner = hDlg;
						bnfo.lpszTitle = "Select output directory...";
						bnfo.ulFlags = BIF_RETURNONLYFSDIRS;
						idlst = SHBrowseForFolder(&bnfo);
						if (idlst) {
							SHGetPathFromIDList(idlst, outputDir);
							IMalloc * imalloc = 0;
							if ( SUCCEEDED( SHGetMalloc(&imalloc)) ) {
								imalloc->Free(idlst);
								imalloc->Release();
							}
							SendDlgItemMessage(hwnd, IDC_EDIT1, WM_SETTEXT, 0, (LPARAM)outputDir);
						}
					}
					break;
				case IDC_COMBO1:
					if (HIWORD(wParam) == CBN_SELENDOK) {
						wavetype = (WAVTYPE) SendDlgItemMessage(hwnd, IDC_COMBO1, CB_GETCURSEL, 0,0);
					}
					break;
				default:
					for (i = 0; i < numMachines; i++) {
						if (machines[i].buttonRec == (HWND)lParam) {
							machines[i].pmi->gval.volume = 0xffff;
							machines[i].pmi->gval.record = (SendMessage(machines[i].buttonRec, BM_GETCHECK, 0,0) == BST_CHECKED);
							machines[i].pmi->gval.output = SWITCH_NO;
							machines[i].pmi->Tick();
						}
					}
					return 0;
			}
			break;
		case WM_PAINT:
			{
				bool updateAll = true;
				if (GetUpdateRect(hDlg, &updateRect, false)) {
					if (updateRect.left == invalidRect.left && 
						updateRect.top == invalidRect.top && 
						updateRect.right == invalidRect.right && 
						updateRect.bottom == invalidRect.bottom)
					{
						hdc = GetDC(hwnd);
						updateAll = false;
						if (!bbdc) {
							bbdc = CreateCompatibleDC(hdc);
							bm = CreateCompatibleBitmap(hdc, 12,130);
							green_l = CreateSolidBrush(RGB(0,250,0));
							green_d = CreateSolidBrush(RGB(0,140,0));
							red_l = CreateSolidBrush(RGB(250,120,0));
							red_d = CreateSolidBrush(RGB(150,50,0));
							black = CreateSolidBrush(RGB(0,0,0));
							windowc = CreateSolidBrush(GetSysColor(COLOR_MENU));
						}
						SelectObject(bbdc, bm);
						for (i = 0; i < numMachines; i++) {
							int p = i-scrollpos+1;
							if (p >= 0 && p < 9) {
								DrawVUmeter(machines[i].pmi, p);
								BitBlt(hdc, p*75+60,81, 11,129, bbdc, 0,0, SRCCOPY);
								machines[i].pmi->currentMaxValueRight = machines[i].pmi->currentMaxValueLeft = -390.0f;
							}
						}
						ReleaseDC(hwnd, hdc);
					}
				}
				if (updateAll) {
					for (i = 0; i < numMachines; i++) {
						SendMessage(machines[i].groupbox, WM_SETTEXT, (WPARAM)0, (LPARAM)machines[i].pmi->pCB->GetMachineName(machines[i].pmi->deze));
						SendMessage(machines[i].buttonRec, BM_SETCHECK, (WPARAM)(machines[i].pmi->doRecord?BST_CHECKED:BST_UNCHECKED), 0);
						SendMessage(machines[i].sliderVol, TBM_SETPOS, (WPARAM)(bool)true, (LPARAM)(int)(600.0f-machines[i].pmi->volume*400.0f));
						sprintf(voltxt, "%C %3.1f%%", (machines[i].pmi->isStereo?'S':'M'), machines[i].pmi->volume*100);
						SendMessage(machines[i].text, WM_SETTEXT, 0, (LPARAM)voltxt);
						sprintf(voltxt, "%dHz", machines[i].pmi->samplerate);
						SendDlgItemMessage(hDlg, IDC_SMPRATE, WM_SETTEXT, 0, (LPARAM)voltxt);
					}
				}
				if (updateScroll) {
					for (i = 0; i < numMachines; i++) {
						setMixerColumnPos(i);
					}
				}
			}
			break;
		case WM_LBUTTONDOWN:
		case WM_LBUTTONUP:
		case WM_MOUSEMOVE:
		case WM_CONTEXTMENU:
			break;
		case WM_VSCROLL:
			for (i = 0; i < numMachines; i++) {
				if (machines[i].sliderVol == (HWND)lParam) {
					float vol = (float)HIWORD(wParam);
					machines[i].pmi->gval.volume = (int) ((600.0f-vol)*109.225);
					machines[i].pmi->gval.record = SWITCH_NO;
					machines[i].pmi->gval.output = SWITCH_NO;
					machines[i].pmi->Tick();
					//sprintf(voltxt, "%C %3.1f%%", (machines[i].pmi->isStereo?'S':'M'), machines[i].pmi->volume*100);
					//SendMessage(machines[i].text, WM_SETTEXT, 0, (LPARAM)voltxt);
				}
			}
			break;
		case WM_HSCROLL:
			switch(LOWORD (wParam)) {
				case SB_PAGEUP:
				case SB_LINEUP:
					scrollpos -= 1;
					if (scrollpos < 1) { scrollpos = 1; }
					break;
				case SB_PAGEDOWN:
				case SB_LINEDOWN:
					scrollpos += 1;
					if (scrollpos > numMachines) { scrollpos = numMachines; }
					break;
				case SB_THUMBPOSITION:
				case SB_THUMBTRACK:
					scrollpos = HIWORD(wParam);
					if (scrollpos < 1) { scrollpos = 1; }
					if (scrollpos > numMachines) { scrollpos = numMachines; }
					break;
				default:
					break;
			}
			hscrl.fMask  = SIF_POS;
			hscrl.nPos   = scrollpos;
			SetScrollInfo(hwnd, SB_HORZ, &hscrl, TRUE);
			updateScroll = true;
			break;
		case (WM_USER+13):
			if (hwnd)
				SendDlgItemMessage(hwnd, IDC_STATUS, WM_SETTEXT, 0, (LPARAM)(LPCTSTR)"Idle...");
			break;
		default:
			break;
	}
	return 0;
}



BOOL WINAPI DllMain (HANDLE hModule, DWORD fwdreason, LPVOID lpReserved) {
	switch (fwdreason) {
		case DLL_PROCESS_ATTACH:
			dllInstance = (HINSTANCE) hModule;
			break;
		case DLL_THREAD_ATTACH: break;
		case DLL_THREAD_DETACH: break;
		case DLL_PROCESS_DETACH: break;
	}
/*
	hThread = CreateThread( 
		NULL,			// no security attributes 
		0,				// use default stack size  
		ThreadFunc,		// thread function 
		&dwThrdParam,	// argument to thread function 
		0,				// use default creation flags 
		&dwThreadId);
	SetThreadPriority(hThread, THREAD_PRIORITY_HIGHEST);
*/
	return TRUE;
}

//HANDLE hThread;
//DWORD dwThreadId;

//DWORD WINAPI ThreadFunc(LPVOID lpParam) { 
//	  p_mi->
//    return 0; 
//}
