/******************************************************
 * Sgorpi MultiTrack Writer
 * By: Hedde Bosman
 * 
 * This code is provided as is, without any warranty.
 * You are free to copy/use the code as long as you 
 * mention my name, in the code and/or about box.
 */
CMachineParameter const paraVol = { pt_word, "Volume",  "Volume",  0, 0xfffe,0xffff,MPF_STATE, 0xaaa9};
CMachineParameter const paraRec = { pt_switch, "Record","Record this effect",SWITCH_OFF,SWITCH_ON,SWITCH_NO,MPF_STATE,SWITCH_ON};
CMachineParameter const paraOut = { pt_switch, "Output","Start/stop output",SWITCH_OFF,SWITCH_ON,SWITCH_NO, 0,SWITCH_OFF};

CMachineParameter const paraCmd = { pt_byte, "Command", "Command", 0, 0xfe,  0xff,  MPF_STATE, 0 };
CMachineParameter const *pParameters[] = {
	&paraVol,
	&paraRec,
	&paraOut,
	// track params
	&paraCmd,
	NULL
};

// This assigns a number to the parameter, used by DescribeValue
enum {
	PARAM_VOL = 0, PARAM_REC, PARAM_OUT, PARAM_CMD,
} miPARAMETERS;

CMachineAttribute const attrMidiIn = { "MIDI in channel (0=all)", 0, 16, 0, };
CMachineAttribute const *pAttributes[] = {
	&attrMidiIn,
	NULL
};

// Machine's info
CMachineInfo const MacInfo = {
	MT_EFFECT, // machine type
	MI_VERSION, // machine version
	0|MIF_DOES_INPUT_MIXING, // flags|MIF_NO_OUTPUT
	0, // min tracks
	miMAX_TRACKS, // max tracks
	3, // #global params
	1, // #track params
	pParameters, // params pointer
	1, // #attributes
	pAttributes, // attrib pointer
	"Sgorpi MultiTrack Writer", // machine name
	"MTWr", // short name
	"Sgorpi", // author
	"Mixer...\nAbout..." // command string
};
